#include <bits/stdc++.h>
#define MAXN 75010

using namespace std;

long long a[MAXN], b[MAXN];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL); cout.tie(NULL);
	
	int t;
	
	cin >> t;
	
	while(t--)
	{
		int n, m;
		
		cin >> n >> m;
		
		for(int i = 0; i < n; i++) cin >> a[i];
		for(int i = 0; i < m; i++) cin >> b[i];
		
		sort(a, a + n);
		
		long long x = a[1] - a[0];
		
		for(int i = 1; i < n - 1; i++)
			x = __gcd(x, a[i + 1] - a[i]);
		
		long long r = a[0] % x;
		
		bool B = true;
		
		for(int i = 0; i < m; i++)
			if(b[i] % x == r) B = false;
			
		if(B) cout << "1\n";
		else cout << "0\n";
	}
	
	return 0;
}